﻿Imports System.Xml

Module App
    Public xmlDoc As XmlDocument
    Public DatabaseTab As TabPage
    Public KeyTab As TabPage
    Public fKey As Integer

    'функции для ini файла
    Private Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpString As String, ByVal lpFileName As String) As Long
    '  Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long

    Public Sub Main()
        DatabaseTab = Nothing
        KeyTab = Nothing

        xmlDoc = New XmlDocument()
        Try
            xmlDoc.Load(My.Resources.xmlFileName)
        Catch ex As System.IO.FileNotFoundException
            'если файла конфигураций нет - создать заготовку xml
            xmlDoc.LoadXml(My.Resources.xmlStr)
        End Try
        InitTabAccount()
        MainForm.Size = New System.Drawing.Size(363, 191)

        'сохранить закладки конфигураций БД и ключа
        DatabaseTab = MainForm.TabControl1.TabPages.Item(1)
        KeyTab = MainForm.TabControl1.TabPages.Item(2)
        fKey = 1
        ShowHideTab()

        MainForm.Size = New System.Drawing.Size(363, 192)
        MainForm.ShowDialog()                          'отобразить главную форму

    End Sub

    Sub ShowHideTab()
        With MainForm
            If fKey = 1 Then
                .TabControl1.TabPages.RemoveAt(2)
                .TabControl1.TabPages.RemoveAt(1)
                '                .Label11.Visible = False
                .Label11.Text = "Press F1 to help"
                .aBtExit.Visible = False
                .aBtOpen.Visible = False
            Else
                If Not DatabaseTab Is Nothing Then .TabControl1.TabPages.Insert(1, DatabaseTab)
                If Not KeyTab Is Nothing Then .TabControl1.TabPages.Insert(2, KeyTab)
                .Label11.Text = "Save and"
                InitTabAccount() 'инициализация закладки Account  
            End If
        End With
    End Sub


    '-----------------------------------------------------------------------------------------------------------
    'Функции закладки Account
    '-----------------------------------------------------------------------------------------------------------
    'инициализация закладки Account    
    Sub InitTabAccount()
        Dim Nodes As XmlNodeList
        Dim Node As XmlNode
        Dim vDatabase, vKey, vLogin, vPassword As String

        'конфигурация Database
        MainForm.aCbDatabase.Items.Clear()
        If Not xmlDoc Is Nothing Then
            Nodes = xmlDoc.selectNodes("//Servers/Server")
            If Not Nodes Is Nothing Then
                For Each Node In Nodes
                    MainForm.aCbDatabase.Items.Add(Node.Attributes("Desc").Value)
                Next
            End If
        End If
        'значение по умолчанию если есть
        vDatabase = xmlDoc.selectSingleNode("//Default/Database").InnerText
        If vDatabase <> "" Then
            MainForm.aCbDatabase.Text = vDatabase
        Else
            If MainForm.aCbDatabase.Items.Count = 0 Then
                MainForm.aCbDatabase.Text = ""
            Else
                MainForm.aCbDatabase.Text = MainForm.aCbDatabase.Items(0).ToString
                SetIntegratedFromAutoLogon()
            End If
        End If

        'конфигурация Key
        MainForm.aCbKey.Items.Clear()
        If Not xmlDoc Is Nothing Then
            Nodes = xmlDoc.selectNodes("//Keys/Key")
            If Not Nodes Is Nothing Then
                For Each Node In Nodes
                    MainForm.aCbKey.Items.Add(Node.Attributes("Desc").Value)
                Next
            End If
        End If
        'значение по умолчанию если есть 
        vKey = xmlDoc.selectSingleNode("//Default/Key").InnerText
        If vKey <> "" Then
            MainForm.aCbKey.Text = vKey
        Else
            If MainForm.aCbKey.Items.Count = 0 Then
                MainForm.aCbKey.Text = ""
            Else
                MainForm.aCbKey.Text = MainForm.aCbKey.Items(0).ToString
            End If
        End If

        'конфигурация Login/Password
        vLogin = xmlDoc.selectSingleNode("//Default/UserID").InnerText
        If vLogin <> "" Then
            MainForm.aTbUserID.Text = vLogin
            vPassword = xmlDoc.selectSingleNode("//Default/Password").InnerText
            If vPassword <> "" Then
                Dim wrapper As New Simple3Des(vLogin)
                Try
                    Dim plainText As String = wrapper.DecryptData(vPassword)
                    MainForm.aTbPassword.Text = plainText
                Catch ex As System.Security.Cryptography.CryptographicException
                    MsgBox("The data could not be decrypted with the password.")
                End Try
            End If
        End If

        'конфигурация Integrated Password
        If xmlDoc.selectSingleNode("//Default/Integrated").InnerText = "1" Then
            MainForm.aChbAutoLogon.Checked = True
        Else
            MainForm.aChbAutoLogon.Checked = False
        End If
        MainForm.aShowBtExitConnect()
    End Sub

    'установить флаг Integrated в соответствии с AutoLogon
    Sub SetIntegratedFromAutoLogon()
        'Dim Node As XmlNode

        'Node = xmlDoc.SelectSingleNode("//Servers/Server[@Desc='" & Form.aCbDatabase.Text & "']")
        'If Not Node Is Nothing Then
        '    If Node.SelectSingleNode("AutoLogon").InnerText = "1" Then
        '        Form.aChbAutoLogon.Checked = True
        '    Else
        '        Form.aChbAutoLogon.Checked = False
        '    End If
        'End If
    End Sub
    '-----------------------------------------------------------------------------------------------------------
    'Функции закладки Database
    '-----------------------------------------------------------------------------------------------------------
    'инициализация закладки Database   
    Sub InitTabDatabase()
        Dim Nodes As XmlNodeList
        Dim Node As XmlNode

        MainForm.dCbDesc.Items.Clear()
        If Not xmlDoc Is Nothing Then
            Nodes = xmlDoc.selectNodes("//Servers/Server")
            If Not Nodes Is Nothing Then
                For Each Node In Nodes '.childNodes
                    MainForm.dCbDesc.Items.Add(Node.Attributes("Desc").Value)
                Next
            End If
        End If

        'значения по умолчанию
        If MainForm.dCbDesc.Items.Count = 0 Then
            MainForm.dCbDesc.Text = ""
            MainForm.dCbDBMS.Text = "Microsoft SQL Server"
            MainForm.dTbServer.Text = ""
            MainForm.dTbDatabase.Text = ""
            MainForm.dTbParameters.Text = ""
            MainForm.dChbAutoLogon.Checked = False
        Else
            MainForm.dCbDesc.Text = MainForm.dCbDesc.Items(0).ToString
        End If
        MainForm.dShowBtSaveDel()
    End Sub

    'прочитать выбранную секцию инициализации
    Sub InitTabDatabaseExt()
        If MainForm.dCbDesc.Items.Count <> 0 Then
            With xmlDoc.SelectSingleNode("//Servers/Server[@Desc='" & MainForm.dCbDesc.Text & "']")
                Select Case .SelectSingleNode("DBMS").InnerText
                    Case "MSSQL"
                        MainForm.dCbDBMS.Text = "Microsoft SQL Server"
                        MainForm.dTbServer.Text = .SelectSingleNode("Server").InnerText
                        MainForm.dTbDatabase.Text = .SelectSingleNode("DataBase").InnerText
                    Case "ORACLE"
                        MainForm.dCbDBMS.Text = "Oracle"
                        Select Case .SelectSingleNode("OraDrv").InnerText
                            Case "O84"
                                MainForm.dCbOraDrv.Text = "Oracle 8, 8i"
                            Case "O90"
                                MainForm.dCbOraDrv.Text = "Oracle 9.0.1"
                        End Select
                        MainForm.dTbServer.Text = .SelectSingleNode("Server").InnerText
                    Case "SQLANY"
                        MainForm.dCbDBMS.Text = "Sybase SQL Anywhere"
                        MainForm.dCbDNS.Text = "Sybase SQL Anywhere (ODBC)"
                        MainForm.dCbDBMSExt.Text = .SelectSingleNode("DSN").InnerText
                    Case "SQLANY;5"
                        MainForm.dCbDBMS.Text = "Sybase SQL Anywhere"
                        MainForm.dCbDNS.Text = "Sybase SQL Anywhere 5.0"
                        MainForm.dTbServer.Text = .SelectSingleNode("Server").InnerText
                        MainForm.dTbDatabase.Text = .SelectSingleNode("DataBase").InnerText
                    Case "SQLANY;6"
                        MainForm.dCbDBMS.Text = "Sybase SQL Anywhere"
                        MainForm.dCbDNS.Text = "Adaptive Server Anywhere 6.0"
                        MainForm.dTbServer.Text = .SelectSingleNode("Server").InnerText
                        MainForm.dTbDatabase.Text = .SelectSingleNode("DataBase").InnerText
                    Case "SQLANY;7"
                        MainForm.dCbDBMS.Text = "Sybase SQL Anywhere"
                        MainForm.dCbDNS.Text = "Adaptive Server Anywhere 7.0"
                        MainForm.dTbServer.Text = .SelectSingleNode("Server").InnerText
                        MainForm.dTbDatabase.Text = .SelectSingleNode("DataBase").InnerText
                    Case "SQLANY;8"
                        MainForm.dCbDBMS.Text = "Sybase SQL Anywhere"
                        MainForm.dCbDNS.Text = "Adaptive Server Anywhere 8.0"
                        MainForm.dTbServer.Text = .SelectSingleNode("Server").InnerText
                        MainForm.dTbDatabase.Text = .SelectSingleNode("DataBase").InnerText
                    Case "SQLANY;9"
                        MainForm.dCbDBMS.Text = "Sybase SQL Anywhere"
                        MainForm.dCbDNS.Text = "Adaptive Server Anywhere 9.0"
                        MainForm.dTbServer.Text = .SelectSingleNode("Server").InnerText
                        MainForm.dTbDatabase.Text = .SelectSingleNode("DataBase").InnerText
                    Case "SQLANY;10"
                        MainForm.dCbDBMS.Text = "Sybase SQL Anywhere"
                        MainForm.dCbDNS.Text = "SQL Anywhere 10"
                        MainForm.dTbServer.Text = .SelectSingleNode("Server").InnerText
                        MainForm.dTbDatabase.Text = .SelectSingleNode("DataBase").InnerText
                End Select
                MainForm.dCbDBMS.Text = .SelectSingleNode("DBMS").InnerText
                MainForm.dTbParameters.Text = .SelectSingleNode("DBParm").InnerText
                If .SelectSingleNode("AutoLogon").InnerText = "1" Then
                    MainForm.dChbAutoLogon.Checked = True
                Else
                    MainForm.dChbAutoLogon.Checked = False
                End If
            End With
        Else
            MainForm.dCbDBMS.Text = "Microsoft SQL Server"
            MainForm.dTbServer.Text = ""
            MainForm.dTbDatabase.Text = ""
            MainForm.dTbParameters.Text = ""
            MainForm.dChbAutoLogon.Checked = False
        End If
        MainForm.dShowBtSaveDel()
    End Sub

    'добавить новую секцию конфигурации
    Sub AddListDatabase()
        Dim Node As XmlNode

        If Trim(MainForm.dCbDesc.Text) <> "" Then
            Node = xmlDoc.SelectSingleNode("//Servers/Server[@Desc='" & Trim(MainForm.dCbDesc.Text) & "']")
            If Node Is Nothing Then
                CreateListDatabase()
                Node = xmlDoc.SelectSingleNode("//Servers/Server[@Desc='" & Trim(MainForm.dCbDesc.Text) & "']")
            End If
            Select Case MainForm.dCbDBMS.Text
                Case "Microsoft SQL Server"
                    Node.SelectSingleNode("DBMS").InnerText = "MSSQL"
                    Node.SelectSingleNode("OraDrv").InnerText = ""
                    Node.SelectSingleNode("DSN").InnerText = ""
                    Node.SelectSingleNode("Server").InnerText = Trim(MainForm.dTbServer.Text)
                    Node.SelectSingleNode("DataBase").InnerText = Trim(MainForm.dTbDatabase.Text)
                Case "Oracle"
                    Node.SelectSingleNode("DBMS").InnerText = "ORACLE"
                    Select Case MainForm.dCbOraDrv.Text
                        Case "Oracle 8, 8i"
                            Node.SelectSingleNode("OraDrv").InnerText = "O84"
                        Case "Oracle 9.0.1"
                            Node.SelectSingleNode("OraDrv").InnerText = "O90"
                    End Select
                    Node.SelectSingleNode("DSN").InnerText = ""
                    Node.SelectSingleNode("Server").InnerText = Trim(MainForm.dTbServer.Text)
                    Node.SelectSingleNode("DataBase").InnerText = ""
                Case "Sybase SQL Anywhere"
                    Select Case MainForm.dCbDNS.Text
                        Case "Sybase SQL Anywhere (ODBC)"
                            Node.SelectSingleNode("DBMS").InnerText = "SQLANY"
                            Node.SelectSingleNode("OraDrv").InnerText = ""
                            Node.SelectSingleNode("DSN").InnerText = Trim(MainForm.dCbDBMSExt.Text)
                            Node.SelectSingleNode("Server").InnerText = ""
                            Node.SelectSingleNode("DataBase").InnerText = ""
                        Case Else
                            Select Case MainForm.dCbDNS.Text
                                Case "Sybase SQL Anywhere 5.0"
                                    Node.SelectSingleNode("DBMS").InnerText = "SQLANY;5"
                                Case "Adaptive Server Anywhere 6.0"
                                    Node.SelectSingleNode("DBMS").InnerText = "SQLANY;6"
                                Case "Adaptive Server Anywhere 7.0"
                                    Node.SelectSingleNode("DBMS").InnerText = "SQLANY;7"
                                Case "Adaptive Server Anywhere 8.0"
                                    Node.SelectSingleNode("DBMS").InnerText = "SQLANY;8"
                                Case "Adaptive Server Anywhere 9.0"
                                    Node.SelectSingleNode("DBMS").InnerText = "SQLANY;9"
                                Case "SQL Anywhere 10"
                                    Node.SelectSingleNode("DBMS").InnerText = "SQLANY;10"
                            End Select
                            Node.SelectSingleNode("OraDrv").InnerText = ""
                            Node.SelectSingleNode("DSN").InnerText = ""
                            Node.SelectSingleNode("Server").InnerText = Trim(MainForm.dTbServer.Text)
                            Node.SelectSingleNode("DataBase").InnerText = Trim(MainForm.dTbDatabase.Text)
                    End Select
            End Select
            Node.SelectSingleNode("DBParm").InnerText = Trim(MainForm.dTbParameters.Text)
            If MainForm.dChbAutoLogon.Checked Then
                Node.SelectSingleNode("AutoLogon").InnerText = "1"
            Else
                Node.SelectSingleNode("AutoLogon").InnerText = "0"
            End If
        End If
        If Not xmlDoc.SelectSingleNode("//Servers/Server[@Desc='" & Trim(MainForm.dCbDesc.Text) & "']") Is Nothing Then InitTabDatabase()
        xmlDoc.Save(My.Resources.xmlFileName)    'Сохраним данные
    End Sub

    'создать пустую секцию конфигурации
    Sub CreateListDatabase()
        Dim Node, nNode As XmlNode

        Node = xmlDoc.SelectSingleNode("//Servers").appendChild(xmlDoc.createElement("Server"))
        Dim attr As XmlAttribute = xmlDoc.CreateAttribute("Desc")
        attr.Value = Trim(MainForm.dCbDesc.Text)
        Node.Attributes.Append(attr)
        nNode = Node.AppendChild(xmlDoc.createElement("AutoLogon"))
        nNode = Node.AppendChild(xmlDoc.createElement("DataBase"))
        nNode = Node.AppendChild(xmlDoc.createElement("DBMS"))
        nNode = Node.AppendChild(xmlDoc.createElement("DBParm"))
        nNode = Node.AppendChild(xmlDoc.createElement("DSN"))
        nNode = Node.AppendChild(xmlDoc.createElement("OraDrv"))
        nNode = Node.AppendChild(xmlDoc.createElement("Server"))
    End Sub

    'удалить существующую секцию конфигурации
    Sub DelListDatabase()
        Dim Node As XmlNode

        If Trim(MainForm.dCbDesc.Text) <> "" Then
            Node = xmlDoc.SelectSingleNode("//Servers/Server[@Desc='" & Trim(MainForm.dCbDesc.Text) & "']")
            If Not Node Is Nothing Then
                Node.ParentNode.RemoveChild(Node)
                xmlDoc.selectSingleNode("//Default/Database").InnerText = ""
                xmlDoc.selectSingleNode("//Default/Key").InnerText = ""
                InitTabDatabase()
                xmlDoc.Save(My.Resources.xmlFileName)    'Сохраним данные
            End If
        End If
    End Sub

    '-----------------------------------------------------------------------------------------------------------
    'Функции закладки Key
    '-----------------------------------------------------------------------------------------------------------
    'инициализация закладки Key   
    Sub InitTabKey()
        Dim Nodes As XmlNodeList
        Dim Node As XmlNode

        MainForm.kCbDesc.Items.Clear()
        If Not xmlDoc Is Nothing Then
            Nodes = xmlDoc.selectNodes("//Keys/Key")
            If Not Nodes Is Nothing Then
                For Each Node In Nodes
                    MainForm.kCbDesc.Items.Add(Node.Attributes("Desc").Value)
                Next
            End If
        End If

        'значения по умолчанию
        If MainForm.kCbDesc.Items.Count = 0 Then
            MainForm.kCbDesc.Text = ""
            MainForm.kTbIp_name.Text = ""
            MainForm.kChbSearch.Checked = True
        Else
            MainForm.kCbDesc.Text = MainForm.kCbDesc.Items(0).ToString
        End If
        MainForm.kShowBtSaveDel()
    End Sub

    'прочитать выбранную секцию инициализации
    Sub InitTabKeyExt()
        If MainForm.kCbDesc.Items.Count <> 0 Then
            With xmlDoc.SelectSingleNode("//Keys/Key[@Desc='" & MainForm.kCbDesc.Text & "']")
                MainForm.kTbIp_name.Text = .SelectSingleNode("IpName").InnerText
                If .SelectSingleNode("IpSearch").InnerText = "1" Then
                    MainForm.kChbSearch.Checked = True
                Else
                    MainForm.kChbSearch.Checked = False
                End If
            End With
        Else
            MainForm.kTbIp_name.Text = ""
            MainForm.kChbSearch.Checked = True
        End If
        MainForm.kShowBtSaveDel()
    End Sub

    'добавить новую секцию конфигурации
    Sub AddListKey()
        Dim Node, nNode As XmlNode

        If Trim(MainForm.kCbDesc.Text) <> "" Then
            Node = xmlDoc.SelectSingleNode("//Keys/Key[@Desc='" & Trim(MainForm.kCbDesc.Text) & "']")
            If Not Node Is Nothing Then
                Node.SelectSingleNode("IpName").InnerText = MainForm.kTbIp_name.Text
                If MainForm.kChbSearch.Checked Then
                    Node.SelectSingleNode("IpSearch").InnerText = "1"
                Else
                    Node.SelectSingleNode("IpSearch").InnerText = "0"
                End If
            Else
                Node = xmlDoc.SelectSingleNode("//Keys").appendChild(xmlDoc.createElement("Key"))
                Dim attr As XmlAttribute = xmlDoc.CreateAttribute("Desc")
                attr.Value = Trim(MainForm.kCbDesc.Text)
                Node.Attributes.Append(attr)
                nNode = Node.AppendChild(xmlDoc.createElement("IpName"))
                nNode.InnerText = MainForm.kTbIp_name.Text
                nNode = Node.AppendChild(xmlDoc.createElement("IpSearch"))
                If MainForm.kChbSearch.Checked Then
                    nNode.InnerText = "1"
                Else
                    nNode.InnerText = "0"
                End If
                InitTabKey()
            End If
        End If
        xmlDoc.Save(My.Resources.xmlFileName)    'Сохраним данные
    End Sub

    'удалить существующую секцию конфигурации
    Sub DelListKey()
        Dim Node As XmlNode
        If Trim(MainForm.kCbDesc.Text) <> "" Then
            Node = xmlDoc.SelectSingleNode("//Keys/Key[@Desc='" & Trim(MainForm.kCbDesc.Text) & "']")
            If Not Node Is Nothing Then
                Node.ParentNode.RemoveChild(Node)       'удалить секцию
                xmlDoc.selectSingleNode("//Default/Database").InnerText = ""
                xmlDoc.selectSingleNode("//Default/Key").InnerText = ""
                InitTabKey()
                xmlDoc.Save(My.Resources.xmlFileName)    'Сохраним данные
            End If
        End If
    End Sub
    '-----------------------------------------------------------------------------------------------------------

    'сохранить текущую секцию конфигурации
    Sub xmlSave()
        xmlDoc.selectSingleNode("//Default/Database").InnerText = MainForm.aCbDatabase.Text
        xmlDoc.selectSingleNode("//Default/Key").InnerText = MainForm.aCbKey.Text
        xmlDoc.selectSingleNode("//Default/UserID").InnerText = MainForm.aTbUserID.Text
        If MainForm.aChbAutoLogon.Checked Then
            xmlDoc.selectSingleNode("//Default/Integrated").InnerText = "1"
        Else
            xmlDoc.selectSingleNode("//Default/Integrated").InnerText = "0"
        End If

        Dim wrapper As New Simple3Des(MainForm.aTbUserID.Text)
        xmlDoc.selectSingleNode("//Default/Password").InnerText = wrapper.EncryptData(MainForm.aTbPassword.Text)

        xmlDoc.Save(My.Resources.xmlFileName)    'Сохраним данные
    End Sub

    'обновить записи в реестре
    Sub SetReg()
        Dim rk As Microsoft.Win32.RegistryKey

        rk = Microsoft.Win32.Registry.CurrentUser.CreateSubKey("Software\LotsiaSoft\PartY\WS.INI\DataBase")
        With xmlDoc.SelectSingleNode("//Servers/Server[@Desc='" & MainForm.aCbDatabase.Text & "']")
            If Not rk.GetValue("AutoLogon") Is .SelectSingleNode("AutoLogon").InnerText Then rk.SetValue("AutoLogon", .SelectSingleNode("AutoLogon").InnerText)
            If Not rk.GetValue("DataBase") Is .SelectSingleNode("DataBase").InnerText Then rk.SetValue("DataBase", .SelectSingleNode("DataBase").InnerText)
            If Not rk.GetValue("DBMS") Is .SelectSingleNode("DBMS").InnerText Then rk.SetValue("DBMS", .SelectSingleNode("DBMS").InnerText)
            If Not rk.GetValue("DBParm") Is .SelectSingleNode("DBParm").InnerText Then rk.SetValue("DBParm", .SelectSingleNode("DBParm").InnerText)
            If Not rk.GetValue("DSN") Is .SelectSingleNode("DSN").InnerText Then rk.SetValue("DSN", .SelectSingleNode("DSN").InnerText)
            If Not rk.GetValue("OraDrv") Is .SelectSingleNode("OraDrv").InnerText Then rk.SetValue("OraDrv", .SelectSingleNode("OraDrv").InnerText)
            If Not rk.GetValue("Server") Is .SelectSingleNode("Server").InnerText Then rk.SetValue("Server", .SelectSingleNode("Server").InnerText)
        End With
        With xmlDoc.selectSingleNode("//Default")
            If Not rk.GetValue("Integrated") Is .SelectSingleNode("Integrated").InnerText Then rk.SetValue("Integrated", .SelectSingleNode("Integrated").InnerText)
            If Not rk.GetValue("UserID") Is .SelectSingleNode("UserID").InnerText Then rk.SetValue("UserID", .SelectSingleNode("UserID").InnerText)
        End With
        rk.Close() ' закрываешь реестр после записи 
    End Sub

    'обновить секцию файла ключа
    Sub SetGuardant()
        Dim rk As Microsoft.Win32.RegistryKey
        Dim paths, pathd, IpName, IpSearch As String
        Dim Node As XmlNode

        Node = xmlDoc.SelectSingleNode("//Keys/Key[@Desc='" & MainForm.aCbKey.Text & "']")
        IpName = Trim(Node.SelectSingleNode("IpName").InnerText)
        If Trim(Node.SelectSingleNode("IpSearch").InnerText) = "1" Then
            IpSearch = "ON"
        Else
            IpSearch = "OFF"
        End If

        rk = Microsoft.Win32.Registry.CurrentUser.CreateSubKey("Software\LotsiaSoft\PartY\AttributeMailFly")
        paths = CStr(rk.GetValue("RunPath", "No Value")) ', RegistryValueOptions.DoNotExpandEnvironmentNames)
        pathd = CStr(rk.GetValue("PartyPath", "No Value")) ', RegistryValueOptions.DoNotExpandEnvironmentNames)
        rk.Close() ' закрываешь реестр после записи 

        'редактировать ini guardant в Programm Files
        WritePrivateProfileString("SERVER", "IP_NAME", IpName, pathd & "\gnclient.ini")
        WritePrivateProfileString("SERVER", "SEARCH", IpSearch, pathd & "\gnclient.ini")

        'редактировать ini guardant в Application Data и скопировать его в Programm Files
        'Dim SrcFile, DestFile
        'SrcFile = paths & "\gnclient.ini" ' Путь к файлу с его именем
        'DestFile = pathd & "\gnclient1.ini" ' путь с именем файла куда копировать
        'FileCopy(SrcFile, DestFile) ' Собственно, копирование 
        ''My.Computer.FileSystem.CopyFile(SrcFile, DestFile, True)

    End Sub

    'Запустить LotsiaPDM Plus с параметрами
    Sub LotsiaRun(ByVal mode As Integer)
        Dim rk As Microsoft.Win32.RegistryKey
        Dim path As String
        Dim RetVal As Integer

        rk = Microsoft.Win32.Registry.CurrentUser.CreateSubKey("Software\LotsiaSoft\PartY\AttributeMailFly")
        path = CStr(rk.GetValue("PartyPath", "No Value")) ', RegistryValueOptions.DoNotExpandEnvironmentNames)
        rk.Close()
        If mode = 0 Then
            path = path & "\partyp.EXE"
        Else
            path = path & "\partyp.EXE -uid=" & Trim(MainForm.aTbUserID.Text) & " -pwd=" & Trim(MainForm.aTbPassword.Text) '& " -max"
        End If

        RetVal = Shell(CStr(path), AppWinStyle.NormalFocus)
    End Sub

    Sub DelObject()
        If Not xmlDoc Is Nothing Then xmlDoc = Nothing
        If Not DatabaseTab Is Nothing Then DatabaseTab = Nothing
        If Not KeyTab Is Nothing Then KeyTab = Nothing
    End Sub

End Module